-- Imports
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Thror.CrosserOfRoads.StepDescriptions"

-- Variables
StatCommand = Turbine.ShellCommand()
MaxStepCount = 46
CurStepCount = 1

-- Main window
CORWindow=Turbine.UI.Lotro.Window();
CORWindow:SetSize(400,400);
CORWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-100,Turbine.UI.Display:GetHeight()/2-100);
CORWindow:SetText("Crosser of roads guide");
CORWindow:SetWantsKeyEvents(true);

-- Step Label
CORWindow.CurStep=Turbine.UI.Label();
CORWindow.CurStep:SetParent(CORWindow);
CORWindow.CurStep:SetSize(400,20); 
CORWindow.CurStep:SetPosition(0,30);
CORWindow.CurStep:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
CORWindow.CurStep:SetText("Current step: " .. CurStepCount .. "/" .. MaxStepCount);

-- Previous Step Button
CORWindow.PrevStep=Turbine.UI.Lotro.Button();
CORWindow.PrevStep:SetParent(CORWindow);
CORWindow.PrevStep:SetSize(70,20); 
CORWindow.PrevStep:SetPosition(100,50);
CORWindow.PrevStep:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
CORWindow.PrevStep:SetText("Previous");

-- Next Step Button
CORWindow.NextStep=Turbine.UI.Lotro.Button();
CORWindow.NextStep:SetParent(CORWindow);
CORWindow.NextStep:SetSize(70,20); 
CORWindow.NextStep:SetPosition(220,50);
CORWindow.NextStep:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
CORWindow.NextStep:SetText("Next");

-- Description Label
CORWindow.DescriptionLabel=Turbine.UI.Label();
CORWindow.DescriptionLabel:SetParent(CORWindow);
CORWindow.DescriptionLabel:SetSize(380,300); 
CORWindow.DescriptionLabel:SetPosition(10,70);
CORWindow.DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftTop); 
CORWindow.DescriptionLabel:SetText("Description:");

-- Description Label
CORWindow.StepDescription=Turbine.UI.Label();
CORWindow.StepDescription:SetParent(CORWindow);
CORWindow.StepDescription:SetSize(380,300); 
CORWindow.StepDescription:SetPosition(10,90); 
CORWindow.StepDescription:SetTextAlignment(Turbine.UI.ContentAlignment.LeftTop); 
CORWindow.StepDescription:SetText(StepDescriptionText[CurStepCount]); 

-- Update Description
function UpdateDescription()
	CORWindow.CurStep:SetText("Current step: " .. CurStepCount .. "/" .. MaxStepCount);
	CORWindow.StepDescription:SetText(StepDescriptionText[CurStepCount]);
end

-- Capture escape key to close the window
CORWindow.KeyDown=function(sender,args)
    if args.Action==145  then
        CORWindow:SetVisible(not CORWindow:IsVisible());
    end
end

-- Previous Step Click Handler
CORWindow.PrevStep.MouseClick=function()
    if (CurStepCount > 1) then
		CurStepCount = CurStepCount - 1;
		UpdateDescription();
	end
end

-- Next Step Click Handler
CORWindow.NextStep.MouseClick=function()
    if (CurStepCount < MaxStepCount) then
		CurStepCount = CurStepCount + 1;
		UpdateDescription();
	end
end

-- handle the plugin commands
function StatCommand:Execute( command, arguments )
	if ( arguments == "show" ) then
		CORWindow:SetVisible(true)
	elseif ( arguments == "hide" ) then
		CORWindow:SetVisible(false)
	elseif ( arguments ~= nil ) then
		StatCommand:GetHelp(command);
	end
end

--return help command
function StatCommand:GetHelp(command)
	Turbine.Shell.WriteLine( "/COR help \n" .. 
	"/COR show : to show the window\n" ..
	"/COR hide : to hide the window\n" ..
	"/CrosserOfRoads help \n" .. 
	"/CrosserOfRoads show : to show the window \n" ..
	"/CrosserOfRoads hide : to hide the window"		);
end

-- Add Shell commands
Turbine.Shell.AddCommand( "COR", StatCommand );
Turbine.Shell.AddCommand( "CrosserOfRoads", StatCommand );

-- Show window
CORWindow:SetVisible(true);